#include <getopt.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <dlfcn.h>
#define dbg_printf(...) ((*alias_printf)(__VA_ARGS__))

int (*alias_printf)(const char *__restrict__ format, ...);
static int verbose = 0;
static char *help_msg = "\nWelcome!\n\
This is a basic algorithm to subtract y from x. \
Requires that y >= 0.\n\n";

int dummy(const char *__restrict__ format, ...) {
  return (int)sizeof(format);
}

int subtract(int x, int y) {
  if (y < 0) {
    dbg_printf("Argument y must be non-negative, got %d\n", y);
    exit(-1);
  }
  do {
    dbg_printf("x = %d, y = %d\n", x, y);
    fflush(stdout);
    usleep(500 * 1000);
  } while (y-- && (--x || !x));
  return x;
}

int main (int argc, char **argv) {
  extern char *optarg;
  extern int optind, opterr, optopt;
  int opt, x, y = 0;
  alias_printf = &dummy;
  
	/* looping over arguments */
  /* ':' means mandatory input */
	while ((opt = getopt(argc,argv,"hvdx:y:")) != -1) {
		switch(opt) {
    case 'h': /* help option */
      printf("%s\n", help_msg);
      break;

    case 'v': /* verbose option */
      verbose = 1;
      break;

    case 'd': /* debug option */
      alias_printf = &printf;
      break;

		case 'x':
			x = atoi(optarg);
			break;

    case 'y':
      y = atoi(optarg);
      break;

		default:
			printf("wrong argument\n");
			break;
		}
	}

    /* Test verbose option */
    if (verbose) {
      printf("Inputs: \n\tx = %d\n\ty = %d\n", x, y);
      printf("Subtracting...\n");
    }
    
  /* Subtraction routine */
  printf("Difference: %d\n", subtract(x, y));
  exit(0);
}