/*
 * 15-213 C Bootcamp
 *
 * This file includes a usage of unions in C.
 *
 * Yosef Alsuhaibani (yalsuhai)
 */
#include<stdio.h>
#include<stdlib.h>
#include<stdbool.h>
#include<string.h>

/* Dr.evil's impl */
union bad_union {

    long num;
    char str[8];
};

/* requin's Fix! */
struct requin_union {

    bool flag;
    union bad_union u;
};


void bad_union_print(union bad_union *u) {

    /* we don't know what field of the union
    * is populated; let's always guess it is
    * char[8] str.
    */
    printf("%s",u->str);

}

void union_print(struct requin_union *s) {

    if(s->flag) {

        printf("%s\n",s->u.str);
    }
    else {

        printf("%ld\n",s->u.num);
    }

}

int main() {

    union bad_union u;
    u.num = 0x0048414841484148;
    bad_union_print(&u);
    u.num = 0xFFFFFFFFFFFFFFFF;
    //Trys to Print a non-Null terminated string!
    //bad_union_print(&u)
   
    /* Requin's fix!
    struct requin_union s;
    s.flag = true;
    strncpy(s.u.str,"\nChomp!",8);
    union_print(&s);
    s.flag = false;
    s.u.num = 0xFFFFFFFFFFFFFFFF;
    union_print(&s);
    */
	
    return 0;
}
